	/*
    Two Key On Hack - PalmOS Hack turn on Palm V with contrast key + other key.

    Copyright (C) 2002 Jarrod Ribble

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	*/



#include <PalmOS.h>

#define appid '2koh'

#define resid 1000

void MySysTrapSleep (Boolean untilReset, Boolean emergency) {
	UInt32 keystate, temp;
	void (*oldtrap)(Boolean, Boolean);

	// call old trap
	FtrGet (appid, resid, &temp);
	oldtrap = (void (*)(Boolean, Boolean)) temp;
	oldtrap(untilReset, emergency);

	if (untilReset || emergency) {
		return;
	}

	// loop until the contrast key is pressed
	keystate = KeyCurrentState();
	while (!(keystate & keyBitContrast)){
		SysSleep (0, 0);
		keystate = KeyCurrentState();
	}
}
